Attribute VB_Name = "vars"
Option Explicit

'_________________________________________________________
'Dieses Modul enthlt alle ffentlichen Variablen
'und Funktionen zur Suche nach Datenstzen in der
'Kanten, Knoten etc. Datenbank
'und mathematische Funktionen
'
'FindNextNode(XPos As Long, YPos As Long) gibt Index des nchsten Knoten an XPos, YPos
'PythA(ByVal a As Single, ByVal b As Single) Pythagoras addition
'AktualiseDistanceLabels()
'AktualiseLength()
'RemoveNode(lNodeIndex As Long) Knoten entfernen
'RemoveEdge(lEdgeIndex As Long) Kante entfernen
'SetEdge() Kante erstellen
'SetNode() Knoten erstellen
'_________________________________________________________

'Wert, der grer ist als die grte mgliche Strecke
Public Const cINFINITY As Long = 1000000000

Public Const cPI As Double = 3.14159265358979

Public Type tNodes                              'Knoten
    XPos As Double                              'an den Koordinaten
    YPos As Double                              'XPos/YPos
    ConnectedToNode() As Boolean                'Verbunden mit Knoten im Index?
    ConnectedOverEdge() As Long                 'Verbunden mit Knoten im
End Type                                        'Index ber Kante

Public Type tEdges
    StartNodeIndex As Long                      'Kante geht von hier
    EndNodeIndex As Long                        'bis hier
    length As Double                            'Lnge der Kante
End Type

Public Nodes() As tNodes                        'Array fr Knoten
Public Edges() As tEdges                        'Array fr Kanten

'Lnge der Krzesten Verbindung zum Knoten mit dem selben Index
Public dDistance() As Double
                                                
'lToNode(v) = u; d.h. man muss ber u, um zu v zu kommmen
Public lToNode() As Long

Public lWaitingNodes As Long                    'Anzahl der Knoten auf der Warteliste
Public lWaitingList() As Long                   'Warteliste

Public lCountNodes As Long                      'Anzahl der Knoten
Public lCountEdges As Long                      '...        Kanten

Public lSetEdgeState As Long                    'Status der Kantensetzung

Public dCarSpeed As Double                      'Bewegungsgeschwindigkeit des Autos

Public lStartNodeIndex As Long                  'Startknoten fr Berechnung und spter Bewegung
Public lLastNodeIndex As Long                   'letzter angefahrener Knoten
Public lNextNodeIndex As Long                   'nchster anzufahrender Knoten
Public lDestNodeIndex As Long                   'Zielknoten
Public lCurrentEdgeIndex As Long                'aktuelle Kante
Public dgegkat As Double, dankat As Double      'fr Berechnung des Bewegungswinkels
Public dDirection As Double                     'Bewegungsrichtung ber die aktuelle Kante
Public dCarPosX As Double                       'X-Koordinate des Autos
Public dCarPosY As Double                       'Y-Koordinate des Autos
Public lTimeCounter As Long                     'Zhler fr Rechendauer
Public bShortestWaysReady As Boolean            'Ist der Weg berechnet? Noch aktuell?

Public lMoveNodeIndex As Long                   'Index fr Knoten, der bewegt wird

Public lDragStartX As Long                      'Startkoordinaten frs Verwschieben von Labels
Public lDragStartY As Long
Public lDragState As Boolean                    'wird gerade gezogen?

Public lActMousePosX As Long, lActMousePosY As Long   'Mausposition

Public sBGPicPath As String                     'Pfad fr zum Hintergrundbild



Public Function FindNextNode(lFromX As Long, lFromY As Long)
    'nchsten Knoten von einer Position, hier meist Mausposition mit Pythagoras ermitteln
    
    Dim lLowestDistance As Long, lDistance As Double, n As Long
    
    On Error GoTo seterrorcode
    
    lLowestDistance = -1
    
    If lCountNodes = 0 Then GoTo seterrorcode
    For n = 0 To lCountNodes - 1
        lDistance = PythA(lFromX - Nodes(n).XPos, lFromY - Nodes(n).YPos)
        If lLowestDistance = -1 Or lLowestDistance > lDistance Then
            lLowestDistance = lDistance
            FindNextNode = n
        End If
    Next n
    
seterrorcode:
    If lLowestDistance = -1 Then FindNextNode = -1
    
End Function

Public Function PythA(ByVal a As Single, ByVal b As Single) As Single   'Pythagoras addition

    PythA = Sqr(a * a + b * b)

End Function

Public Sub AktualiseDistanceLabels()

    Dim n As Long
    
    For n = 0 To lCountNodes - 1
        With frmshortpaths.lbldistances(n)
            .Visible = frmshortpaths.mnudistances(2).Checked
            If dDistance(n) = cINFINITY Then
                .Caption = "-"
            Else
                .Caption = Round(dDistance(n), 2)
            End If
        End With
    Next n
    
End Sub

Public Sub AktualiseLength()
    
    Dim n As Long
    
    For n = 0 To lCountEdges - 1
        With Edges(n)
            .length = PythA(Nodes(.StartNodeIndex).XPos - Nodes(.EndNodeIndex).XPos, _
                            Nodes(.StartNodeIndex).YPos - Nodes(.EndNodeIndex).YPos)
        End With
        With frmshortpaths.lbledges(n)
            .Visible = frmshortpaths.mnulength(3).Checked
            .Caption = Round(Edges(n).length, 2)
        End With
    Next n
    
End Sub

Public Sub RemoveNode(lNodeIndex As Long)
    
    Dim n As Long, m As Long
    
    For n = 0 To lCountNodes - 1 'angrenzende Kanten lschen
        If Nodes(lNodeIndex).ConnectedToNode(n) Then
            m = Nodes(lNodeIndex).ConnectedOverEdge(n)
            RemoveEdge m
        End If
    Next n
    
    For n = 0 To lCountEdges - 1          'Verknpfungen zu den nachrutschenden Knoten
        If Edges(n).StartNodeIndex > lNodeIndex Then
            Edges(n).StartNodeIndex = Edges(n).StartNodeIndex - 1
        End If
        If Edges(n).EndNodeIndex > lNodeIndex Then
            Edges(n).EndNodeIndex = Edges(n).EndNodeIndex - 1
        End If
    Next n
    
    'Verbindungsinfos neu machen
    For n = 0 To lCountNodes - 1
        For m = 0 To lCountNodes - 1
            Nodes(n).ConnectedToNode(m) = False
        Next m
    Next n
    
    For n = 0 To lCountEdges - 1
        With Edges(n)
            Nodes(.StartNodeIndex).ConnectedOverEdge(.EndNodeIndex) = n
            Nodes(.StartNodeIndex).ConnectedToNode(.EndNodeIndex) = True
            Nodes(.EndNodeIndex).ConnectedOverEdge(.StartNodeIndex) = n
            Nodes(.EndNodeIndex).ConnectedToNode(.StartNodeIndex) = True
        End With
    Next n
    
    For n = lNodeIndex To lCountNodes - 2  'Knoten nachrcken lassen
        With Nodes(n)
            .XPos = Nodes(n + 1).XPos
            .YPos = Nodes(n + 1).YPos
        End With
        With frmshortpaths.lbldistances(n)
            .Caption = frmshortpaths.lbldistances(n + 1).Caption
            .Left = frmshortpaths.lbldistances(n + 1).Left
            .Top = frmshortpaths.lbldistances(n + 1).Top
        End With
    Next n
    
    If lCountNodes > 1 Then
        Unload frmshortpaths.lbldistances(lCountNodes - 1)
    Else
        frmshortpaths.lbldistances(lCountNodes - 1).Visible = False
    End If
    
    lCountNodes = lCountNodes - 1
    If lCountNodes > 0 Then ReDim Preserve Nodes(0 To lCountNodes - 1)
    
    AktualiseLength
    
End Sub

Public Sub RemoveEdge(lEdgeIndex As Long)
    
    Dim n As Long, m As Long
    
    'Kanten nachrcken
    For n = lEdgeIndex To lCountEdges - 2
        Edges(n).EndNodeIndex = Edges(n + 1).EndNodeIndex
        Edges(n).StartNodeIndex = Edges(n + 1).StartNodeIndex
        Edges(n).length = Edges(n + 1).length
        frmshortpaths.lbledges(n).Left = frmshortpaths.lbledges(n + 1).Left
        frmshortpaths.lbledges(n).Top = frmshortpaths.lbledges(n + 1).Top
    Next n
        
    If lCountEdges > 1 Then
        Unload frmshortpaths.lbledges(lCountEdges - 1)
    Else
        frmshortpaths.lbledges(lCountEdges - 1).Visible = False
    End If
    lCountEdges = lCountEdges - 1
    If lCountEdges > 0 Then ReDim Preserve Edges(0 To lCountEdges - 1)
    
    For n = 0 To lCountNodes - 1
        For m = 0 To lCountNodes - 1
            If Nodes(n).ConnectedOverEdge(m) > lEdgeIndex Then
                Nodes(n).ConnectedOverEdge(m) = Nodes(n).ConnectedOverEdge(m) - 1
            ElseIf Nodes(n).ConnectedOverEdge(m) = lEdgeIndex Then
                Nodes(n).ConnectedToNode(m) = False
            End If
        Next m
    Next n

End Sub

Public Sub SetEdge()
    
    Dim lSelectedNodeIndex As Long, n As Long
    
    lSetEdgeState = lSetEdgeState + 1                           'Fortschrittzhler erhhen
    
    If lSetEdgeState = 1 Then       '1. Knoten wird ausgewhlt
        lSelectedNodeIndex = FindNextNode(lActMousePosX, lActMousePosY) 'nchster Knoten zur Maus ausgewhlt
        If lSelectedNodeIndex > -1 Then                              'wenn (nchster) Knoten vorhanden,
            lCountEdges = lCountEdges + 1                                   'Kantenzhler erhhen
            ReDim Preserve Edges(0 To lCountEdges - 1)
            Edges(lCountEdges - 1).StartNodeIndex = lSelectedNodeIndex     'Startknoten setzen
            Edges(lCountEdges - 1).EndNodeIndex = -1                      'Endknoten initialisieren
            frmshortpaths.lblmessage.Caption = "Zielknoten anklicken; Rechtsklick fr Abbruch"
        Else                                                            'sonst:
            lSetEdgeState = 0                                         'Knotenauswahl abbrechen
            Exit Sub
        End If
        
    ElseIf lSetEdgeState = 2 Then    '2. Knoten wird ausgewhlt
        
        lSelectedNodeIndex = FindNextNode(lActMousePosX, lActMousePosY) 'nchster Knoten zur Maus ausgewhlt
        If lSelectedNodeIndex > -1 And lSelectedNodeIndex <> Edges(lCountEdges - 1).StartNodeIndex Then
            'wenn (nchster) Knoten vorhanden ist und Start- und Zielknoten unterschiedlich sind
            Edges(lCountEdges - 1).EndNodeIndex = lSelectedNodeIndex       'Zielknoten speichern
            For n = 0 To lCountEdges - 2
                If Edges(n).StartNodeIndex = Edges(lCountEdges - 1).StartNodeIndex And _
                   Edges(n).EndNodeIndex = Edges(lCountEdges - 1).EndNodeIndex Or _
                   Edges(n).StartNodeIndex = Edges(lCountEdges - 1).EndNodeIndex And _
                   Edges(n).EndNodeIndex = Edges(lCountEdges - 1).StartNodeIndex Then   'wenn Kante schon vorhanden ist
                    lSetEdgeState = 1                                             'auswahl ignorieren
                    Exit Sub
                End If
            Next n
            'Kante endgltig hinzufgen
            With Edges(lCountEdges - 1) 'Lnge der neuen Kante berechnen
                .length = PythA(Nodes(.StartNodeIndex).XPos - Nodes(.EndNodeIndex).XPos, Nodes(.StartNodeIndex).YPos - Nodes(.EndNodeIndex).YPos)
            End With
            If lCountEdges > 1 Then Load frmshortpaths.lbledges(lCountEdges - 1)
            With frmshortpaths.lbledges(lCountEdges - 1)        'Lngenanzeige einrichten
                .Left = 300 + (Nodes(Edges(lCountEdges - 1).StartNodeIndex).XPos + Nodes(Edges(lCountEdges - 1).EndNodeIndex).XPos) / 2
                .Top = -150 + (Nodes(Edges(lCountEdges - 1).StartNodeIndex).YPos + Nodes(Edges(lCountEdges - 1).EndNodeIndex).YPos) / 2
                .Caption = Round(Edges(lCountEdges - 1).length, 2)
                .Visible = frmshortpaths.mnulength(3).Checked
            End With
            
            frmshortpaths.lblmessage.Caption = "Auf Startknoten klicken"
            AktualiseNodeIndexLabels frmshortpaths.mnunodeindex(0).Checked
            AktualiseEdgeIndexLabels frmshortpaths.mnuedgeindex(1).Checked
            bShortestWaysReady = False
            
            'Verbindungsinformationen: welcher Knoten ist mit welchem verbunden?
            '                          und ber welche Kante?
            Nodes(Edges(lCountEdges - 1).StartNodeIndex).ConnectedToNode(Edges(lCountEdges - 1).EndNodeIndex) = True
            Nodes(Edges(lCountEdges - 1).EndNodeIndex).ConnectedToNode(Edges(lCountEdges - 1).StartNodeIndex) = True
            Nodes(Edges(lCountEdges - 1).StartNodeIndex).ConnectedOverEdge(Edges(lCountEdges - 1).EndNodeIndex) = lCountEdges - 1
            Nodes(Edges(lCountEdges - 1).EndNodeIndex).ConnectedOverEdge(Edges(lCountEdges - 1).StartNodeIndex) = lCountEdges - 1

        Else                                                        'wenn keiner oder nur 1 Knoten vorhanden ist
            lCountEdges = lCountEdges - 1                                   'Kante lschen und Knoten setzen vorschlagen
            If lCountEdges > 0 Then
                ReDim Preserve Edges(0 To lCountEdges - 1)
            Else
                frmshortpaths.optnode.Value = True
            End If
        End If
        lSetEdgeState = 0                                             'Knotenauswahl neu beginnen
    End If
    
End Sub

Public Sub SetNode()
    
    Dim n As Long
    
    For n = 0 To lCountNodes - 1          'neuer Knoten muss min. 10 Pixel von allen anderen Knoten entfernt sein
        If PythA(Nodes(n).XPos - lActMousePosX, _
            Nodes(n).YPos - lActMousePosY) < 150 Then Exit Sub
    Next n
    
    lCountNodes = lCountNodes + 1                                       'Zhler erhhen
    ReDim Preserve Nodes(0 To lCountNodes - 1)
    ReDim Preserve lToNode(0 To lCountNodes - 1)
    ReDim Preserve dDistance(0 To lCountNodes - 1)
    
    Nodes(lCountNodes - 1).XPos = lActMousePosX                        'Position speichern
    Nodes(lCountNodes - 1).YPos = lActMousePosY
    
    For n = 0 To lCountNodes - 1            'alle dDistance(n) = unendlich
        dDistance(n) = cINFINITY
        ReDim Preserve Nodes(n).ConnectedToNode(0 To lCountNodes - 1)
        ReDim Preserve Nodes(n).ConnectedOverEdge(0 To lCountNodes - 1)
    Next n
    If lCountNodes > 1 Then Load frmshortpaths.lbldistances(lCountNodes - 1)
    With frmshortpaths.lbldistances(lCountNodes - 1)
        .Left = Nodes(lCountNodes - 1).XPos + 150
        .Top = Nodes(lCountNodes - 1).YPos - 150
        .Caption = "-"
        .Visible = frmshortpaths.mnulength(3).Checked
    End With
    
    bShortestWaysReady = False
    AktualiseNodeIndexLabels frmshortpaths.mnunodeindex(0).Checked
    AktualiseEdgeIndexLabels frmshortpaths.mnuedgeindex(1).Checked

End Sub

Public Sub AktualiseNodeIndexLabels(Visible As Boolean)
    
    Dim n As Integer
    
    If lCountNodes = 0 Then
        frmshortpaths.lblnodeindex(0).Visible = False
        Exit Sub
    End If
    
On Error GoTo gotcha
    n = 1
    Do While 1
        Unload frmshortpaths.lblnodeindex(n)
        n = n + 1
    Loop
gotcha:
    
    frmshortpaths.lblnodeindex(0).Caption = 0
    frmshortpaths.lblnodeindex(0).Left = Nodes(0).XPos
    frmshortpaths.lblnodeindex(0).Top = Nodes(0).YPos - 300
    frmshortpaths.lblnodeindex(0).Visible = Visible
    
    For n = 1 To lCountNodes - 1
        Load frmshortpaths.lblnodeindex(n)
        frmshortpaths.lblnodeindex(n).Caption = n
        frmshortpaths.lblnodeindex(n).Left = Nodes(n).XPos
        frmshortpaths.lblnodeindex(n).Top = Nodes(n).YPos - 300
        frmshortpaths.lblnodeindex(n).Visible = Visible
    Next n
    
End Sub

Public Sub AktualiseEdgeIndexLabels(Visible As Boolean)
    
    Dim n As Integer
    
    If lCountEdges = 0 Then
        frmshortpaths.lbledgeindex(0).Visible = False
        Exit Sub
    End If
    
On Error GoTo gotcha
    n = 1
    Do While 1
        Unload frmshortpaths.lbledgeindex(n)
        n = n + 1
    Loop
gotcha:
    
    frmshortpaths.lbledgeindex(0).Caption = 0
    frmshortpaths.lbledgeindex(0).Left = (Nodes(Edges(0).StartNodeIndex).XPos + Nodes(Edges(0).EndNodeIndex).XPos) / 2
    frmshortpaths.lbledgeindex(0).Top = (Nodes(Edges(0).StartNodeIndex).YPos + Nodes(Edges(0).EndNodeIndex).YPos) / 2 - 300
    frmshortpaths.lbledgeindex(0).Visible = Visible
    
    For n = 1 To lCountEdges - 1
        Load frmshortpaths.lbledgeindex(n)
        frmshortpaths.lbledgeindex(n).Caption = n
        frmshortpaths.lbledgeindex(n).Left = (Nodes(Edges(n).StartNodeIndex).XPos + Nodes(Edges(n).EndNodeIndex).XPos) / 2
        frmshortpaths.lbledgeindex(n).Top = (Nodes(Edges(n).StartNodeIndex).YPos + Nodes(Edges(n).EndNodeIndex).YPos) / 2 - 300
        frmshortpaths.lbledgeindex(n).Visible = Visible
    Next n
    
End Sub

Public Function GetNextOnList() As Long
    'nchsten Knoten auf der Warteliste
    
    Dim n As Long, dShortestLen As Double
    
    dShortestLen = cINFINITY
    GetNextOnList = -1
    For n = 0 To lWaitingNodes - 1
        If dDistance(lWaitingList(n)) < dShortestLen Then
            dShortestLen = dDistance(lWaitingList(n))
            GetNextOnList = lWaitingList(n)
        End If
    Next n
    
End Function

Public Sub AddToList(NodeIndex As Long)
    'Knoten zur Warteliste hinzufgen
    
    Dim n As Long
    
    For n = 0 To lWaitingNodes - 1
        If lWaitingList(n) = NodeIndex Then Exit Sub
    Next n
    
    lWaitingNodes = lWaitingNodes + 1
    ReDim Preserve lWaitingList(0 To lWaitingNodes - 1)
    lWaitingList(lWaitingNodes - 1) = NodeIndex
    
End Sub

Public Sub RemoveFromList(NodeIndex As Long)
    'Knoten von Warteliste entfernen
    
    Dim n As Long, m As Long
    
    If n = lWaitingNodes Then Exit Sub  'wenn NodeIndex nicht vorhanden ist
    Do Until lWaitingList(n) = NodeIndex
        n = n + 1
        If n = lWaitingNodes Then Exit Sub  'wenn NodeIndex nicht vorhanden ist
    Loop
    
    
    For m = n To lWaitingNodes - 2
        lWaitingList(m) = lWaitingList(m + 1)
    Next m
    
    lWaitingNodes = lWaitingNodes - 1
    If lWaitingNodes > 0 Then ReDim Preserve lWaitingList(0 To lWaitingNodes - 1)
    
End Sub
